> For the complete documentation index, see [llms.txt](https://docs.n8n.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.n8n.io/deploy/host-n8n/configure-n8n/basic-configuration/use-environment-variables/endpoints.md).

# Endpoints

{% hint style="info" %}
**File-based configuration**

You can add `_FILE` to individual variables to provide their configuration in a separate file. Refer to [Keeping sensitive data in separate files](/deploy/host-n8n/configure-n8n/basic-configuration.md#keeping-sensitive-data-in-separate-files) for more details.
{% endhint %}

This page lists environment variables for customizing endpoints in n8n.

| Variable                                        | Type    | Default           | Description                                                                                                                                                                                                                                                                                                                                                 |
| ----------------------------------------------- | ------- | ----------------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `N8N_PAYLOAD_SIZE_MAX`                          | Number  | `16`              | The maximum payload size in MiB. The default is 16 MiB, but this can be increased by adjusting the variable to a higher value. The n8n instance needs to be restarted to apply the new setting. Note: Increasing the payload size requires more memory and CPU resources and may impact performance. Ensure your infrastructure can handle larger payloads. |
| `N8N_FORMDATA_FILE_SIZE_MAX`                    | Number  | `200`             | Max payload size for files in form-data webhook payloads in MiB.                                                                                                                                                                                                                                                                                            |
| `N8N_METRICS`                                   | Boolean | `false`           | Whether to enable the `/metrics` endpoint.                                                                                                                                                                                                                                                                                                                  |
| `N8N_METRICS_PREFIX`                            | String  | `n8n_`            | Optional prefix for n8n specific metrics names.                                                                                                                                                                                                                                                                                                             |
| `N8N_METRICS_INCLUDE_DEFAULT_METRICS`           | Boolean | `true`            | Whether to expose default system and node.js metrics.                                                                                                                                                                                                                                                                                                       |
| `N8N_METRICS_INCLUDE_CACHE_METRICS`             | Boolean | false             | Whether to include metrics (true) for cache hits and misses, or not include them (false).                                                                                                                                                                                                                                                                   |
| `N8N_METRICS_INCLUDE_MESSAGE_EVENT_BUS_METRICS` | Boolean | `false`           | Whether to include metrics (true) for events, or not include them (false).                                                                                                                                                                                                                                                                                  |
| `N8N_METRICS_INCLUDE_WORKFLOW_ID_LABEL`         | Boolean | `false`           | Whether to include a label for the workflow ID on workflow metrics.                                                                                                                                                                                                                                                                                         |
| `N8N_METRICS_INCLUDE_NODE_TYPE_LABEL`           | Boolean | `false`           | Whether to include a label for the node type on node metrics.                                                                                                                                                                                                                                                                                               |
| `N8N_METRICS_INCLUDE_CREDENTIAL_TYPE_LABEL`     | Boolean | `false`           | Whether to include a label for the credential type on credential metrics.                                                                                                                                                                                                                                                                                   |
| `N8N_METRICS_INCLUDE_API_ENDPOINTS`             | Boolean | `false`           | Whether to expose metrics for API endpoints.                                                                                                                                                                                                                                                                                                                |
| `N8N_METRICS_INCLUDE_API_PATH_LABEL`            | Boolean | `false`           | Whether to include a label for the path of API invocations.                                                                                                                                                                                                                                                                                                 |
| `N8N_METRICS_INCLUDE_API_METHOD_LABEL`          | Boolean | `false`           | Whether to include a label for the HTTP method (GET, POST, ...) of API invocations.                                                                                                                                                                                                                                                                         |
| `N8N_METRICS_INCLUDE_API_STATUS_CODE_LABEL`     | Boolean | `false`           | Whether to include a label for the HTTP status code (200, 404, ...) of API invocations.                                                                                                                                                                                                                                                                     |
| `N8N_METRICS_INCLUDE_QUEUE_METRICS`             | Boolean | `false`           | Whether to include metrics for jobs in scaling mode.                                                                                                                                                                                                                                                                                                        |
| `N8N_METRICS_QUEUE_METRICS_INTERVAL`            | Integer | `20`              | How often (in seconds) to update queue metrics.                                                                                                                                                                                                                                                                                                             |
| `N8N_METRICS_INCLUDE_SSRF_METRICS`              | Boolean | `false`           | Whether to include metrics for SSRF protection checks.                                                                                                                                                                                                                                                                                                      |
| `N8N_METRICS_INCLUDE_DNS_CACHE_METRICS`         | Boolean | `false`           | Whether to include metrics for the DNS cache (currently only used by SSRF protection).                                                                                                                                                                                                                                                                      |
| `N8N_ENDPOINT_REST`                             | String  | `rest`            | The path used for REST endpoint.                                                                                                                                                                                                                                                                                                                            |
| `N8N_ENDPOINT_WEBHOOK`                          | String  | `webhook`         | The path used for webhook endpoint.                                                                                                                                                                                                                                                                                                                         |
| `N8N_ENDPOINT_WEBHOOK_TEST`                     | String  | `webhook-test`    | The path used for test-webhook endpoint.                                                                                                                                                                                                                                                                                                                    |
| `N8N_ENDPOINT_WEBHOOK_WAIT`                     | String  | `webhook-waiting` | The path used for waiting-webhook endpoint.                                                                                                                                                                                                                                                                                                                 |
| `N8N_ENDPOINT_HEALTH`                           | String  | `healthz`         | The path used for health check endpoint.                                                                                                                                                                                                                                                                                                                    |
| `WEBHOOK_URL`                                   | String  | -                 | Used to manually provide the Webhook URL when running n8n behind a reverse proxy. See [here](/deploy/host-n8n/configure-n8n/basic-configuration/configuration-examples/configure-webhook-urls-with-reverse-proxy.md) for more details.                                                                                                                      |
| `N8N_DISABLE_PRODUCTION_MAIN_PROCESS`           | Boolean | `false`           | Disable production webhooks from main process. This helps ensure no HTTP traffic load to main process when using webhook-specific processes.                                                                                                                                                                                                                |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.n8n.io/deploy/host-n8n/configure-n8n/basic-configuration/use-environment-variables/endpoints.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
